/*
 * i2c.h - header file of the i2c.c
 *
 * Copyright (C) 2009 by Magic Control Technology Inc. 
 *
 * If distributed as part of the Linux kernel, this code is licensed under the
 * terms of the GPL v2.
 *
 * Otherwise, the following license terms apply:
 *
 * * Redistribution and use in source and binary forms, with or without
 * * modification, are permitted provided that the following conditions
 * * are met:
 * * 1) Redistributions of source code must retain the above copyright
 * *    notice, this list of conditions and the following disclaimer.
 * * 2) Redistributions in binary form must reproduce the above copyright
 * *    notice, this list of conditions and the following disclaimer in the
 * *    documentation and/or other materials provided with the distribution.
 * * 3) The name of the author may not be used to endorse or promote products
 * *    derived from this software without specific psisusbr written permission.
 * *
 * * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESSED OR
 * * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *	Authors:
 *		Louis Tsai	    <louis@mct.com.tw>
 */

#ifndef _I2C_H
#define _I2C_H

#define I2C_PAGE_SIZE	8

void I2CInitial(struct sisusb_usb_data *sisusb);
BOOLEAN I2C_WriteByte (struct sisusb_usb_data *sisusb, UCHAR SlaveID, UCHAR addr, UCHAR data);
BOOLEAN I2C_ReadByte (struct sisusb_usb_data *sisusb, UCHAR SlaveID, UCHAR addr, UCHAR *data);
BOOLEAN I2C_WriteMultipleBytes (struct sisusb_usb_data *sisusb, UCHAR SlaveID, UCHAR addr, USHORT count, UCHAR *pdata);
BOOLEAN I2C_ReadMultipleBytes (struct sisusb_usb_data *sisusb, UCHAR SlaveID, UCHAR addr, USHORT count, UCHAR *pdata);
//for Atmel
BOOLEAN Read_Atmel_Func (struct sisusb_usb_data *sisusb, PREAD_ATMEL pReadAteml, UCHAR *outBuf);
BOOLEAN Write_Ateml_Func (struct sisusb_usb_data *sisusb, UCHAR *buf, ULONG count);
BOOLEAN ATmelAckPolling (struct sisusb_usb_data *sisusb, ULONG cmd);
BOOLEAN CheckATMel (struct sisusb_usb_data *sisusb);
#endif