#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/signal.h>
#include <linux/sched.h>
#include <linux/errno.h>
#include <linux/poll.h>
#include <linux/init.h>
#include <linux/slab.h>
#include <linux/spinlock.h>
#include <asm/delay.h>
#include <linux/kref.h>
#include <linux/usb.h>
#include <linux/smp_lock.h>
#include <linux/vmalloc.h>
#include <linux/mutex.h>
#include "Tusb.h"


extern int ReadRegisterByte(struct sisusb_usb_data *sisusb, u16 reg, u8 *data);
extern int WriteRegisterByte(struct sisusb_usb_data *sisusb,u32 reg,u32 data);
extern int SendBlockCommand(struct sisusb_usb_data *sisusb,u32 epindex,unsigned char *pdata,u32 users,u32 len);
extern void TransferBlockData(struct sisusb_usb_data *sisusb,
		       u32		 SrcX,
		       u32		 SrcY,
		       u32		 DestX,
		       u32		 DestY,
		       u32		 ColorFormat,
		       u32		 SrcBitsPlane,
		       u32		 ScrXPoint,
		       u32		 ScrYPoint,
		       u32		 ScreenLineLen,
		       u32		 HScale,
		       u32		 VScale,
		       unsigned char*	 pdata,
		       int               users,
		       u32		 len);
extern void WriteGPIO(struct sisusb_usb_data *sisusb, UCHAR Mask, UCHAR andMask, UCHAR orMask);

static void pixel_clk_par(ULONG pixel_clk, UCHAR *fcf3, UCHAR *fcf4, UCHAR *fcf5, UCHAR *fcf6, UCHAR *fcf7)
{
	int	m,n, i, l, pll1_div, pll1_decide, pll2_div, pll2_decide, count;
	int	pll1_n, pll1_m, pll2_n, pll2_m;
	double f_in = 12;
	double f_out, pll1_out, pll2_out;
	double dev;
	double cal_in, cal;
	double mm, mm1, finish, pll2_check;
	double fPixelClock;
	unsigned char done, ggyy;
	
	done = 0;

	dev = 0.01; /// default
	fPixelClock = (double)pixel_clk / 1000000;
	printk ("PixelClock : %lf\n", fPixelClock);
/// caculate the frequency
	pll1_out = 0.0;
	pll2_out = 0.0;
	finish = 0;
	for ( ggyy = 1; ggyy < 32; ggyy++ ) {
		if( (finish > 0.0) )
			break;
		for ( m = 1; m < 64; m++ ) {
			if( (finish > 0.0) )
				break;
			for ( n = 1; n < (64 * 12); n++ ) {
				if( (finish > 0.0) )
					break;
				f_out = (f_in * n) / m;
				if(fPixelClock > f_out)
					cal_in = (fPixelClock - f_out);
				if(fPixelClock <= f_out)
					cal_in = (f_out - fPixelClock);
				cal = (cal_in);
				if(cal < dev) {					
					//// decide m
					for ( l = 1; l < (m + 1); l++) {
						if( (finish > 0.0) )
							break;
						pll1_div = (m / l);
						pll1_decide = m - pll1_div * l;
						if((pll1_decide == 0)) {
						   pll2_m = pll1_div;
						   pll1_m = l;
						   for ( count = 1; count < (n + 1); count++ ) {
								if( (finish > 0.0) )
									break;
								pll2_div = (n / count);
								pll2_decide = n - pll2_div * count;
								if((pll2_decide == 0)) {
								   pll2_n = pll2_div;
								   pll1_n = count;
								
									/// check the limitation
									pll1_out = 12.0 * pll1_n / pll1_m;
									pll2_out = pll1_out * pll2_n / pll2_m;
									pll2_check = pll1_out / pll2_m;
									if(pll1_out < 300 && pll1_out > 20 &&
									   pll1_m < 12 && pll1_n < 64 &&
									   pll2_m < 64 && pll2_n < 64 &&
									   pll2_check > 1.0 ) {
										//printf(" the result is pixel_clk = %f ;  \n",fPixelClock);
										printk(" 0xfcf6 = %x  (hex);  \n",pll1_m);
										printk(" 0xfcf7 = %x  (hex);  \n",pll1_n);
										printk(" 0xfcf3 = %x  (hex);  \n",pll2_m);
										printk(" 0xfcf4 = %x  (hex);  \n",pll2_n);
										*fcf3 = (UCHAR)pll2_m;
										*fcf4 = (UCHAR)pll2_n;
										*fcf6 = (UCHAR)pll1_m;
										*fcf7 = (UCHAR)pll1_n;
										if(pll1_out > 100.0) {
											if(pll2_out > 100.0) {
												printk(" 0xfcf5 = 0x11  (hex);  \n");
												*fcf5 = 0x11;
											}
											else {
												printk(" 0xfcf5 = 0x10  (hex);  \n");
												*fcf5 = 0x10;
											}
										}
										else {
											if(pll2_out > 100.0) {
												printk(" 0xfcf5 = 0x01  (hex);  \n");
												*fcf5 = 0x01;
											}
											else {
												printk(" 0xfcf5 = 0x00  (hex);  \n");
												*fcf5 = 0x00;
											}
										}
										finish = 1.0;
										done = 1;
									}  /// pll2_check
								} /// pll2_decide		
							} /// count
						}  /// pll1_decide
 					}  /// l loop
				} /// if(cal ..
			}  /// n
		} 	/// m	
		dev = dev + 0.1;
	} /// while
}

static BOOLEAN ClearScreen (struct sisusb_usb_data *sisusb, ULONG ColorFormat)
{
	 // make the screen black
     TransferBlockData (sisusb, 
     					sisusb->hres, sisusb->vres, 
     					sisusb->hres, sisusb->vres,
     					ColorFormat, sisusb->bpp, 
     					0, 0, sisusb->hres*3, 
     					NO_SCALE, NO_SCALE, 
     					NULL,0, 0);

	return TRUE;
}

//**************************************************************************************
static BOOLEAN VgaSetModeByTiming_SDRAM(struct sisusb_usb_data *sisusb, ULONG modeIndex)
{
	ULONG OutVRes, OutHRes, ColorFormat;
    UCHAR ColorInfo;
    UCHAR Cmd[50];
    UCHAR i;
	UCHAR fcf0=0, fcf1=0, fcf2=0, fcf3=0, fcf4=0, fcf5=0, fcf6=0, fcf7=0;
	ULONG ulA3;
	UCHAR A3;
	ULONG size = 1;
	BOOLEAN bReadA3 = FALSE;
	  	
    if (sisusb->Phase != 0x00)
		A3 = sisusb->Phase;
	else
		A3 = 0x60;
	
	printk ("SDRAM Phase = %x\n", A3);
#if 1
    if (sisusb->PixClock > 40000000)
    	sisusb->ucScalingClock = 0x81;	//60M
    else if (sisusb->PixClock > 25000000)
    	sisusb->ucScalingClock = 0x82;	//48M
    else
    	sisusb->ucScalingClock = 0x80;	//30M
#else
	sisusb->ucScalingClock = 0x81;	//60M
#endif 	
    printk ("Scaling Clock: %x\n", sisusb->ucScalingClock);

   	//Fix 144M SDRAM clock
    fcf0 = 0x04;
    fcf1 = 0x30;
    fcf2 = 0x01;   
    A3 |= 0x02;	//data phase select 
    pixel_clk_par (sisusb->PixClock, &fcf3, &fcf4, &fcf5, &fcf6, &fcf7);

	//reset the pDevExt->hres and pDevExt->vres
	sisusb->hres = sisusb->HW_hres = sisusb->HActive;
	sisusb->vres = sisusb->HW_vres = sisusb->VActive;
	if (sisusb->HW_hres == 1400)
		sisusb->HW_hres = 1408;	
    
	switch(modeIndex) {
	case 0:
		sisusb->ColorFormat=ColorFormat=COLOR_PALETTE;
		break;
	case 1:
	    sisusb->ColorFormat=ColorFormat=RGB16;
		break;
	case 2:
	default:
	    sisusb->ColorFormat=ColorFormat=RGB32;
		break;
	}
	OutHRes = sisusb->HW_hres;
	OutVRes = sisusb->HW_vres;
	
     //yulw: 0512 for trigger 2 clear buffer
    WriteRegisterByte(sisusb, 0xFC28,0x01); 
    WriteRegisterByte(sisusb, 0xFC59,0x01); 
    WriteRegisterByte(sisusb, 0xFC32,0x00);
    WriteRegisterByte(sisusb, 0xFC34,0x00);  
    //     
    WriteRegisterByte(sisusb, 0xFCB0,0);    //disable.
    WriteRegisterByte(sisusb, 0xFCB0,0x20);
    // Disable PLL
	WriteRegisterByte(sisusb, 0xFC4b,0x00);
	//WriteRegisterByte(DevExt, 0xFC4b,0x1C);
	//yulw: 0512 for trigger2 
	mdelay(10); //10ms
	WriteRegisterByte (sisusb, 0xfbff, sisusb->ucScalingClock);
	Cmd[0] = 0x04;
	Cmd[2] = 0;
    i = 3;
    // Enable the PLL
    //SDRAM	
    //03.09.08
    //Fix SDRAM clock to 144M
    //WriteRegisterByte(DevExt, 0xFCF0,0x04);
    Cmd[i++] = 0xf0;
    Cmd[i++] = fcf0;
    //Cmd[i++] = 0x04;
	//WriteRegisterByte(DevExt, 0xFCF1,0x13);	
    Cmd[i++] = 0xf1;
    Cmd[i++] = fcf1;		
    //Cmd[i++] = 0x30;
	// range
	//WriteRegisterByte(DevExt, 0xFCF2,0x00);	
    Cmd[i++] = 0xf2;
    Cmd[i++] = fcf2;		
    //Cmd[i++] = 0x01;
	// VGA
	//WriteRegisterByte(DevExt, 0xFCF3,0x01);	
    Cmd[i++] = 0xf3;
    Cmd[i++] = fcf3;		
	//WriteRegisterByte(DevExt, 0xFCF4,0x01);
	Cmd[i++] = 0xf4;
    Cmd[i++] = fcf4;
	//WriteRegisterByte(DevExt, 0xFCF6,0x0a);
    Cmd[i++] = 0xf6;
    Cmd[i++] = fcf6;		
	//WriteRegisterByte(DevExt, 0xFCF7,0x15);
    Cmd[i++] = 0xf7;
    Cmd[i++] = fcf7;		
		
	//WriteRegisterByte(DevExt, 0xFCF5,0x00);
    Cmd[i++] = 0xf5;
    Cmd[i++] = fcf5;		
		
	Cmd[i++] = 0xa3;
	Cmd[i++] = A3 | sisusb->A3Bit2;		
		
	// clock enable
	//WriteRegisterByte(DevExt, 0xFC4b,0x07);
    Cmd[i++] = 0x4b;
	if ((sisusb->VGA_Output_Type == DVO_24) && (sisusb->bEnableDAC == FALSE))
			Cmd[i++] = 0x0F;
		else						
			Cmd[i++] = 0x07;
    Cmd[1] = i-3;
	
	SendBlockCommand(sisusb,3, Cmd, 0, i);     	
	mdelay(10);

	i=3;
	// initial SDRAM
	//WriteRegisterByte(DevExt, 0xFCA4,0x37);
    Cmd[i++] = 0xa4;
    Cmd[i++] = 0x37;		
	//WriteRegisterByte(DevExt, 0xFCA3,0x81);

    Cmd[i++] = 0xa3;
    Cmd[i++] = A3 | 0x01 | sisusb->A3Bit2;		
		
    Cmd[i++] = 0xa3;
    Cmd[i++] = A3 | sisusb->A3Bit2;
    
	// Clear the buffer
	//WriteRegisterByte(DevExt, 0xFC28,0x01);
    Cmd[i++] = 0x28;
    Cmd[i++] = 0x01;		
	//WriteRegisterByte(DevExt, 0xFC28,0x00);
    Cmd[i++] = 0x28;
    Cmd[i++] = 0x00;		
	//WriteRegisterByte(DevExt, 0xFC32,0x00);
    Cmd[i++] = 0x32;
    Cmd[i++] = 0x00;		
	//WriteRegisterByte(DevExt, 0xFC59,0x01);
    Cmd[i++] = 0x59;
    Cmd[i++] = 0x01;	
	//WriteRegisterByte(DevExt, 0xFC59,0x00);
    Cmd[i++] = 0x59;
    Cmd[i++] = 0x00;
	//WriteRegisterByte(DevExt, 0xFC34,0x00);
    Cmd[i++] = 0x34;
    Cmd[i++] = 0x00; 		

	/// Horizontal
	//WriteRegisterByte(DevExt, 0xFCC4, 0x7f);  /// HGATE    : 
   	Cmd[i++] = 0xc4;
   	Cmd[i++] = (UCHAR)((sisusb->HW_hres-1)&0x00ff);
	//WriteRegisterByte(DevExt, 0xFCC5,0x02);	  /// HGATE
   	Cmd[i++] = 0xc5;
   	Cmd[i++] = (UCHAR)(((sisusb->HW_hres-1)>>8)&0x00ff);
	//WriteRegisterByte(DevExt, 0xFCC6,0x2c);	  /// HGATEDEL :	40 -4
   	Cmd[i++] = 0xc6;
   	Cmd[i++] = (UCHAR)((sisusb->HBP-3)&0x00ff);
	//WriteRegisterByte(DevExt, 0xFCC7,0x5f);	  /// HSYNC    : 	32
   	Cmd[i++] = 0xc7;
   	Cmd[i++] = (UCHAR)((sisusb->HSync-1)&0x00ff);

	//WriteRegisterByte(DevExt, 0xFCCE,0x1f);	  /// HLEN     : 400
   	Cmd[i++] = 0xce;
   	Cmd[i++] = (UCHAR)((sisusb->HTotal-1)&0x00ff);
	//WriteRegisterByte(DevExt, 0xFCCF,0x03);	  /// HLEN
   	Cmd[i++] = 0xcf;
   	Cmd[i++] = (UCHAR)(((sisusb->HTotal-1)>>8)&0x00ff);

	/// Vertical
	//WriteRegisterByte(DevExt, 0xFCC8,0xdf);	 /// VGATE    :	240
	Cmd[i++] = 0xc8;
   	Cmd[i++] = (UCHAR)((sisusb->HW_vres-1)&0x00ff);
	//WriteRegisterByte(DevExt, 0xFCC9,0x01);	 /// VGATE	
   	Cmd[i++] = 0xc9;
   	Cmd[i++] = (UCHAR)(((sisusb->HW_vres-1)>>8)&0x00ff);
	//WriteRegisterByte(DevExt, 0xFCCa,0x1d);	 /// VGATEDEL :	6
   	Cmd[i++] = 0xca;
   	Cmd[i++] = (UCHAR)((sisusb->VBP-1)&0x00ff);
	//WriteRegisterByte(DevExt, 0xFCCb,0x01);	 /// VSYNC    :	4
   	Cmd[i++] = 0xcb;
   	Cmd[i++] = (UCHAR)((sisusb->VSync-1)&0x00ff);

	//WriteRegisterByte(DevExt, 0xFCCC,0x0c);	 /// VLEN     :	253
   	Cmd[i++] = 0xcc;
   	Cmd[i++] = (UCHAR)((sisusb->VTotal-1)&0x00ff);
	//WriteRegisterByte(DevExt, 0xFCCD,0x02);	 /// VLEN
   	Cmd[i++] = 0xcd;
   	Cmd[i++] = (UCHAR)(((sisusb->VTotal-1)>>8)&0x00ff);
    	
   	Cmd[1] = i-3;
	SendBlockCommand(sisusb,3, Cmd, 0, i);     	

	i = 3;
	// scaling factor
    //WriteRegisterByte(DevExt, 0xFC40,0);    //low
	Cmd[i++] = 0x40;
   	Cmd[i++] = 0x00;    
    //WriteRegisterByte(DevExt, 0xFC41,0x40); //high
	Cmd[i++] = 0x41;
   	Cmd[i++] = 0x40;    
    //WriteRegisterByte(DevExt, 0xFC42,0);    //low
	Cmd[i++] = 0x42;
   	Cmd[i++] = 0x00;    
    //WriteRegisterByte(DevExt, 0xFC43,0x40); //high
	Cmd[i++] = 0x43;
   	Cmd[i++] = 0x40;    

	// resolution
    //WriteRegisterByte(DevExt, 0xFC36,(UCHAR)((OutHRes)&0xff));	   //low
	Cmd[i++] = 0x36;
   	Cmd[i++] = (UCHAR)((OutHRes)&0xff);    
    //WriteRegisterByte(DevExt, 0xFC37,(UCHAR)((OutHRes>>8)&0xff)); //high
	Cmd[i++] = 0x37;
	Cmd[i++] = (UCHAR)((OutHRes>>8)&0xff);
    //WriteRegisterByte(DevExt, 0xFC38,(UCHAR)((OutVRes)&0xff));	   //low
	Cmd[i++] = 0x38;
	Cmd[i++] = (UCHAR)((OutVRes)&0xff);
    //WriteRegisterByte(DevExt, 0xFC39,(UCHAR)((OutVRes>>8)&0xff)); //high
	Cmd[i++] = 0x39;
	Cmd[i++] = (UCHAR)((OutVRes>>8)&0xff);
     
    // color format 
    if(ColorFormat == YUV444)	 /// YUV444
		ColorInfo = 0x08;	 /// YUV444 enable
    else if(ColorFormat == RGB32)	 /// 32-bit mode
		ColorInfo = 0x0e;	 /// 32-bit enable
    else if(ColorFormat == RGB565)	 /// 16-bit mode BGR565
		ColorInfo=0x04;		 /// BGR565 enable
    else if(ColorFormat == YUV422)	 /// 16-bit mode YUV422
		ColorInfo = 0x8a;	 /// YUV422 enable
	else if (ColorFormat == RGB24)
		ColorInfo = 0x00;		
	else 
		ColorInfo = 0x04;
    //WriteRegisterByte(DevExt, 0xFC34,ColorInfo);
    Cmd[i++] = 0x34;
    Cmd[i++] = ColorInfo;
    Cmd[1] = i-3;
	SendBlockCommand(sisusb,3, Cmd, 0, i);     	

    if(ColorFormat == COLOR_PALETTE)	 /// 8-bit mode	BIT-Map	enable
		WriteRegisterByte(sisusb, 0xFC32,0x02);	 /// Bit Map Fill Start
    else
		WriteRegisterByte(sisusb, 0xFC32,0x00);	 /// Bit Map Fill Start
		
		
	{
		ULONG ScreenSize;
		ULONG Overlay0Addr, Overlay1Addr;
		
		ScreenSize = sisusb->HW_hres * sisusb->HW_vres *3;
		sisusb->Overlay0Addr = ScreenSize;
		sisusb->Overlay1Addr = ScreenSize*2;
		Overlay0Addr = sisusb->Overlay0Addr>>1; //word alignment
		Overlay1Addr = sisusb->Overlay1Addr>>1; //word alignment
		
		Cmd[0] = 0x22;
		Cmd[1] = 8;
		i=2;
		//set OverlayFrame 0 base
		Cmd[i++] = 0xFB;
		Cmd[i++] = 0x65;
		Cmd[i++] = 0x01;
		Cmd[i++] = 0xFB;
		Cmd[i++] = 0x62;
		Cmd[i++] = (UCHAR) Overlay0Addr;
		Cmd[i++] = 0xFB;
		Cmd[i++] = 0x63;
		Cmd[i++] = (UCHAR)(Overlay0Addr>>8);
		Cmd[i++] = 0xFB;
		Cmd[i++] = 0x64;
		Cmd[i++] = (UCHAR)(Overlay0Addr>>16);
		//set OverlayFrame 1 base
		Cmd[i++] = 0xFB;
		Cmd[i++] = 0x65;
		Cmd[i++] = 0x02;
		Cmd[i++] = 0xFB;
		Cmd[i++] = 0x62;
		Cmd[i++] = (UCHAR) Overlay1Addr;
		Cmd[i++] = 0xFB;
		Cmd[i++] = 0x63;
		Cmd[i++] = (UCHAR)(Overlay1Addr>>8);
		Cmd[i++] = 0xFB;
		Cmd[i++] = 0x64;
		Cmd[i++] = (UCHAR)(Overlay1Addr>>16);		
		
		SendBlockCommand(sisusb,3, Cmd, 0, i);
	}

//yulw: set on screen frame 0 address to 0
	WriteRegisterByte(sisusb, 0xFCB4,0x01);
	WriteRegisterByte(sisusb, 0xFCB1,0x00);
	WriteRegisterByte(sisusb, 0xFCB2,0x00);
	WriteRegisterByte(sisusb, 0xFCB3,0x00);
//     

	WriteRegisterByte(sisusb, 0xFB65,0x11);
	WriteRegisterByte(sisusb, 0xFB60,0x0);  // disable overlay
	WriteRegisterByte(sisusb, 0xFCB5,0x03);
     
	
   	WriteRegisterByte(sisusb, 0xFCB4,0x10);	// Display Frame 0
   	//for 24bits RGB Digital output
   	if (sisusb->VGA_Output_Type == DVO_24)
   		WriteRegisterByte (sisusb, 0xFB96, 0x11);
    
    WriteRegisterByte(sisusb, 0xFCB0,0x09);//Enable.
    mdelay(10);
	// make the screen black
    ClearScreen (sisusb, ColorFormat);    
	printk ("VgaSetModeByTiming_SDRAM Exit\n");
	if (sisusb->bBLGpio)	//turn on back light notification
		WriteGPIO (sisusb, sisusb->BLGpioPin, 0xFF, sisusb->BLGpioPin);	

	return TRUE;
}
//**************************************************************************************
static BOOLEAN VgaSetModeByTiming_DDR(struct sisusb_usb_data *sisusb, ULONG modeIndex)
{
	ULONG OutVRes, OutHRes, ColorFormat;
    UCHAR ColorInfo;
    UCHAR Cmd[50];
    UCHAR i;
	UCHAR fcf0=0, fcf1=0, fcf2=0, fcf3=0, fcf4=0, fcf5=0, fcf6=0, fcf7=0;
	ULONG ulA3;
	UCHAR A3, FCA3;
	ULONG size = 1;
	BOOLEAN bReadA3 = FALSE;	

	printk("VgaSetModeByTiming_DDR Set mode=%lx\n",modeIndex);
	
	if (sisusb->Phase != 0x00)
		A3 = sisusb->Phase;
	else
		A3 = 0x80;
	
	printk("DDR Phase : %x\n", A3);
	
	ReadRegisterByte (sisusb, 0xFCA3, &FCA3);
	if ((FCA3&0x06) == 0x06)
		sisusb->bFirstTimePnP = FALSE;
	else
		sisusb->bFirstTimePnP = TRUE;
		
	printk ("0xFCA3 = %x\n", FCA3);

	// trigger2: fix small block update
    if (sisusb->HW_hres > 1280) {
    	WriteRegisterByte(sisusb, 0xFC2F,0x03);
    	WriteRegisterByte(sisusb, 0xFBF6,0x02);
    }
    else {
    	WriteRegisterByte(sisusb, 0xFC2F,0x00);
    	WriteRegisterByte(sisusb, 0xFBF6,0x00);
    }
     //yulw: 0512 for trigger 2 clear buffer
    WriteRegisterByte(sisusb, 0xFC28,0x01); 
    WriteRegisterByte(sisusb, 0xFC59,0x01); 
    WriteRegisterByte(sisusb, 0xFC32,0x00);
    WriteRegisterByte(sisusb, 0xFC34,0x00);  
    //     
    WriteRegisterByte(sisusb, 0xFCB0,0);    //disable.
    WriteRegisterByte(sisusb, 0xFCB0,0x20);
    // Disable PLL
	WriteRegisterByte(sisusb, 0xFC4b,0x00);
	//yulw: 0512 for trigger2 
	mdelay(10);
	//for Trigger2: DDR enable DDR
	WriteRegisterByte(sisusb, 0xFBF2,0x04);
	WriteRegisterByte(sisusb, 0xFBF4,0x03);
	
    pixel_clk_par (sisusb->PixClock, &fcf3, &fcf4, &fcf5, &fcf6, &fcf7);
    fcf0 = 0x01;
    fcf1 = 0x14;
    fcf2 = 0x01;
	sisusb->hres = sisusb->HW_hres = sisusb->HActive;
	sisusb->vres = sisusb->HW_vres = sisusb->VActive;
	if (sisusb->HW_hres == 1400)
		sisusb->HW_hres = 1408;	
    switch(modeIndex) {
	case 0:
	    sisusb->ColorFormat=ColorFormat=COLOR_PALETTE;
		break;
	case 1:
	    sisusb->ColorFormat=ColorFormat=RGB16;
		break;
	case 2:
	default:
	    sisusb->ColorFormat=ColorFormat=RGB32;
		break;
	}
	OutHRes = sisusb->HW_hres;
	OutVRes = sisusb->HW_vres;
	
	WriteRegisterByte (sisusb, 0xfbff, sisusb->ucScalingClock);
	
	
	Cmd[0] = 0x04;
	Cmd[2] = 0;
	i = 3;
    //WriteRegisterByte(DevExt, 0xFCF0,0x04);
    Cmd[i++] = 0xf0;
    Cmd[i++] = fcf0;
    //Cmd[i++] = 0x04;
	//WriteRegisterByte(DevExt, 0xFCF1,0x13);	
    Cmd[i++] = 0xf1;
    Cmd[i++] = fcf1;		
    //Cmd[i++] = 0x30;
	// range
	//WriteRegisterByte(DevExt, 0xFCF2,0x00);	
    Cmd[i++] = 0xf2;
    Cmd[i++] = fcf2;		
    //Cmd[i++] = 0x01;
	// VGA
	//WriteRegisterByte(DevExt, 0xFCF3,0x01);	
    Cmd[i++] = 0xf3;
    Cmd[i++] = fcf3;		
	//WriteRegisterByte(DevExt, 0xFCF4,0x01);
	Cmd[i++] = 0xf4;
    Cmd[i++] = fcf4;
	//WriteRegisterByte(DevExt, 0xFCF6,0x0a);
    Cmd[i++] = 0xf6;
    Cmd[i++] = fcf6;		
	//WriteRegisterByte(DevExt, 0xFCF7,0x15);
    Cmd[i++] = 0xf7;
    Cmd[i++] = fcf7;		
		
	//WriteRegisterByte(DevExt, 0xFCF5,0x00);
    Cmd[i++] = 0xf5;
    Cmd[i++] = fcf5;		

			// waiting the PLL stable time (counter setting)
	Cmd[i++] = 0x4c;  /// address
	Cmd[i++] = 0x00; /// data
	Cmd[i++] = 0x4d;  /// address
	Cmd[i++] = 0x80; /// data

	Cmd[i++] = 0x4e;  /// address
	Cmd[i++] = 0x00; /// data
	Cmd[i++] = 0x4f;  /// address
	Cmd[i++] = 0x80; /// data		
			// clock enable
			//WriteRegisterByte(DevExt, 0xFC4b,0x07);
	Cmd[i++] = 0x4b;
	if ((sisusb->VGA_Output_Type == DVO_24) && (sisusb->bEnableDAC == FALSE))
		Cmd[i++] = 0x0F;
	else						
		Cmd[i++] = 0x07;

	Cmd[1] = i-3;
	SendBlockCommand(sisusb,3, Cmd, 0, i);     			
	mdelay(10);

	i = 3;
	// initial SDRAM
	//WriteRegisterByte(DevExt, 0xFCA4,0x37);
	Cmd[i++] = 0xa4;
	Cmd[i++] = 0x39;		
	//WriteRegisterByte(DevExt, 0xFCA3,0x81);
	if (sisusb->bFirstTimePnP) {
		Cmd[i++] = 0xa3;
		Cmd[i++] = A3 | 0x07;
	}
	//WriteRegisterByte(DevExt, 0xFCA3,0x80);
	Cmd[i++] = 0xa3;
	Cmd[i++] = A3 | 0x06;
	// Clear the buffer
	//WriteRegisterByte(DevExt, 0xFC28,0x01);
	Cmd[i++] = 0x28;
	Cmd[i++] = 0x01;		
	//WriteRegisterByte(DevExt, 0xFC28,0x00);
	Cmd[i++] = 0x28;
	Cmd[i++] = 0x00;	
	//WriteRegisterByte(DevExt, 0xFC32,0x00);
	Cmd[i++] = 0x32;
	Cmd[i++] = 0x00;		    			
	//WriteRegisterByte(DevExt, 0xFC59,0x01);
	Cmd[i++] = 0x59;
	Cmd[i++] = 0x01;	
	//WriteRegisterByte(DevExt, 0xFC59,0x00);
	Cmd[i++] = 0x59;
	Cmd[i++] = 0x00;    	

	//WriteRegisterByte(DevExt, 0xFC34,0x00);
	Cmd[i++] = 0x34;
	Cmd[i++] = 0x00; 		

			/// Horizontal
	//WriteRegisterByte(DevExt, 0xFCC4, 0x7f);  /// HGATE    : 
   	Cmd[i++] = 0xc4;
   	Cmd[i++] = (UCHAR)((sisusb->HW_hres-1)&0x00ff);
	//WriteRegisterByte(DevExt, 0xFCC5,0x02);	  /// HGATE
   	Cmd[i++] = 0xc5;
   	Cmd[i++] = (UCHAR)(((sisusb->HW_hres-1)>>8)&0x00ff);
	//WriteRegisterByte(DevExt, 0xFCC6,0x2c);	  /// HGATEDEL :	40 -4
   	Cmd[i++] = 0xc6;
   	Cmd[i++] = (UCHAR)((sisusb->HBP-3)&0x00ff);
	//WriteRegisterByte(DevExt, 0xFCC7,0x5f);	  /// HSYNC    : 	32
   	Cmd[i++] = 0xc7;
   	Cmd[i++] = (UCHAR)((sisusb->HSync-1)&0x00ff);

	//WriteRegisterByte(DevExt, 0xFCCE,0x1f);	  /// HLEN     : 400
   	Cmd[i++] = 0xce;
   	Cmd[i++] = (UCHAR)((sisusb->HTotal-1)&0x00ff);
	//WriteRegisterByte(DevExt, 0xFCCF,0x03);	  /// HLEN
   	Cmd[i++] = 0xcf;
   	Cmd[i++] = (UCHAR)(((sisusb->HTotal-1)>>8)&0x00ff);

	/// Vertical
	//WriteRegisterByte(DevExt, 0xFCC8,0xdf);	 /// VGATE    :	240
	Cmd[i++] = 0xc8;
   	Cmd[i++] = (UCHAR)((sisusb->HW_vres-1)&0x00ff);
	//WriteRegisterByte(DevExt, 0xFCC9,0x01);	 /// VGATE	
   	Cmd[i++] = 0xc9;
   	Cmd[i++] = (UCHAR)(((sisusb->HW_vres-1)>>8)&0x00ff);
	//WriteRegisterByte(DevExt, 0xFCCa,0x1d);	 /// VGATEDEL :	6
   	Cmd[i++] = 0xca;
   	Cmd[i++] = (UCHAR)((sisusb->VBP-1)&0x00ff);
	//WriteRegisterByte(DevExt, 0xFCCb,0x01);	 /// VSYNC    :	4
   	Cmd[i++] = 0xcb;
   	Cmd[i++] = (UCHAR)((sisusb->VSync-1)&0x00ff);

	//WriteRegisterByte(DevExt, 0xFCCC,0x0c);	 /// VLEN     :	253
   	Cmd[i++] = 0xcc;
   	Cmd[i++] = (UCHAR)((sisusb->VTotal-1)&0x00ff);
	//WriteRegisterByte(DevExt, 0xFCCD,0x02);	 /// VLEN
   	Cmd[i++] = 0xcd;
   	Cmd[i++] = (UCHAR)(((sisusb->VTotal-1)>>8)&0x00ff);

	Cmd[1] = i-3;
	SendBlockCommand(sisusb,3, Cmd, 0, i);
			
	//DevExt->bFirstTimePnP = FALSE;
	
	i = 3;
	// scaling factor
    //WriteRegisterByte(DevExt, 0xFC40,0);    //low
	Cmd[i++] = 0x40;
   	Cmd[i++] = 0x00;    
    //WriteRegisterByte(DevExt, 0xFC41,0x40); //high
	Cmd[i++] = 0x41;
   	Cmd[i++] = 0x40;    
    //WriteRegisterByte(DevExt, 0xFC42,0);    //low
	Cmd[i++] = 0x42;
   	Cmd[i++] = 0x00;    
    //WriteRegisterByte(DevExt, 0xFC43,0x40); //high
	Cmd[i++] = 0x43;
   	Cmd[i++] = 0x40;    

	// resolution
    //WriteRegisterByte(DevExt, 0xFC36,(UCHAR)((OutHRes)&0xff));	   //low
	Cmd[i++] = 0x36;
   	Cmd[i++] = (UCHAR)((OutHRes)&0xff);    
    //WriteRegisterByte(DevExt, 0xFC37,(UCHAR)((OutHRes>>8)&0xff)); //high
	Cmd[i++] = 0x37;
	Cmd[i++] = (UCHAR)((OutHRes>>8)&0xff);
    //WriteRegisterByte(DevExt, 0xFC38,(UCHAR)((OutVRes)&0xff));	   //low
	Cmd[i++] = 0x38;
	Cmd[i++] = (UCHAR)((OutVRes)&0xff);
    //WriteRegisterByte(DevExt, 0xFC39,(UCHAR)((OutVRes>>8)&0xff)); //high
	Cmd[i++] = 0x39;
	Cmd[i++] = (UCHAR)((OutVRes>>8)&0xff);
     
    // color format 
    if(ColorFormat == YUV444)	 /// YUV444
		ColorInfo = 0x08;	 /// YUV444 enable
    else if(ColorFormat == RGB32)	 /// 32-bit mode
		ColorInfo = 0x0e;	 /// 32-bit enable
    else if(ColorFormat == RGB565)	 /// 16-bit mode BGR565
		ColorInfo=0x04;		 /// BGR565 enable
    else if(ColorFormat == YUV422)	 /// 16-bit mode YUV422
		ColorInfo = 0x8a;	 /// YUV422 enable
	else if (ColorFormat == RGB24)
		ColorInfo = 0x00;
	else if (ColorFormat == YUV411)
		ColorInfo = 0x96;			
	else 
		ColorInfo = 0x04;
    //WriteRegisterByte(DevExt, 0xFC34,ColorInfo);
    Cmd[i++] = 0x34;
    Cmd[i++] = ColorInfo;
    Cmd[1] = i-3;
    SendBlockCommand(sisusb, 3, Cmd, 0, i);

    if(ColorFormat == COLOR_PALETTE)	 /// 8-bit mode	BIT-Map	enable
		WriteRegisterByte(sisusb, 0xFC32,0x02);	 /// Bit Map Fill Start
    else
		WriteRegisterByte(sisusb, 0xFC32,0x00);	 /// Bit Map Fill Start
	if (1)
	{
		ULONG ScreenSize;
		ULONG Overlay0Addr, Overlay1Addr;
		
		ScreenSize = sisusb->HW_hres * sisusb->HW_vres *3;
		sisusb->Overlay0Addr = ScreenSize;
		sisusb->Overlay1Addr = ScreenSize*2;
#if 1		
		Overlay0Addr = sisusb->Overlay0Addr>>2; //Dword alignment DDR
		Overlay1Addr = sisusb->Overlay1Addr>>2; //Dword alignment DDR		
#else		
		Overlay0Addr = sisusb->Overlay0Addr>>1; //word alignment
		Overlay1Addr = sisusb->Overlay1Addr>>1; //word alignment
#endif		
		
		Cmd[0] = 0x22;
		Cmd[1] = 8;
		i=2;
		//set OverlayFrame 0 base
		Cmd[i++] = 0xFB;
		Cmd[i++] = 0x65;
		Cmd[i++] = 0x01;
		Cmd[i++] = 0xFB;
		Cmd[i++] = 0x62;
		Cmd[i++] = (UCHAR) Overlay0Addr;
		Cmd[i++] = 0xFB;
		Cmd[i++] = 0x63;
		Cmd[i++] = (UCHAR)(Overlay0Addr>>8);
		Cmd[i++] = 0xFB;
		Cmd[i++] = 0x64;
		Cmd[i++] = (UCHAR)(Overlay0Addr>>16);
		//set OverlayFrame 1 base
		Cmd[i++] = 0xFB;
		Cmd[i++] = 0x65;
		Cmd[i++] = 0x02;
		Cmd[i++] = 0xFB;
		Cmd[i++] = 0x62;
		Cmd[i++] = (UCHAR) Overlay1Addr;
		Cmd[i++] = 0xFB;
		Cmd[i++] = 0x63;
		Cmd[i++] = (UCHAR)(Overlay1Addr>>8);
		Cmd[i++] = 0xFB;
		Cmd[i++] = 0x64;
		Cmd[i++] = (UCHAR)(Overlay1Addr>>16);		
		
		SendBlockCommand(sisusb, 3, Cmd, 0, i);
	}
//yulw: set on screen frame 0 address to 0
	WriteRegisterByte(sisusb, 0xFCB4,0x01);
	WriteRegisterByte(sisusb, 0xFCB1,0x00);
	WriteRegisterByte(sisusb, 0xFCB2,0x00);
	WriteRegisterByte(sisusb, 0xFCB3,0x00);
//     
	WriteRegisterByte(sisusb, 0xFB65,0x11);
	WriteRegisterByte(sisusb, 0xFB60,0x0);  // disable overlay
	WriteRegisterByte(sisusb, 0xFCB5,0x03);
      	
   	WriteRegisterByte(sisusb, 0xFCB4,0x10);	// Display Frame 0
 	   	
   	//for 24bits RGB Digital output
   	if (sisusb->VGA_Output_Type == DVO_24)
   		WriteRegisterByte (sisusb, 0xFB96, 0x11);
  	
   	//
    WriteRegisterByte(sisusb, 0xFCB0,0x09);//Enable.
    mdelay(10);
    // make the screen black
    printk ("Going to clear screen...\n");
    ClearScreen (sisusb, ColorFormat);     
	printk ("VgaSetModeByTiming_DDR Exit\n");

	if (sisusb->bBLGpio)	//turn on back light notification
		WriteGPIO (sisusb, sisusb->BLGpioPin, 0xFF, sisusb->BLGpioPin);	

	return TRUE;
}
//**************************************************************************************
BOOLEAN VgaSetModeByPanelCfg(struct sisusb_usb_data *sisusb, ULONG ModeIndex)
{
	if (sisusb->DRAM_TYPE == TYPE_SDRAM)
		VgaSetModeByTiming_SDRAM(sisusb,ModeIndex);
	else
   		VgaSetModeByTiming_DDR(sisusb,ModeIndex); 
   	
   	return TRUE;
}