//#define userTest_DBG
#define userTest_DRAWIMG

#include <stdio.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <time.h>
//#include <delay.h>
//#include "Tusb.h"

typedef enum {
	MODE_640X480X8X60=0,
	MODE_640X480X8X75,		//0x01
	MODE_640X480X16X60,		//0x02
	MODE_640X480X16X75,		//0x03

	MODE_640X480X24X60,		//0x04
	MODE_640X480X24X75,		//0x05
	MODE_640X480X32X60, 	//0x06
	MODE_640X480X32X75,		//0x07

	MODE_800X600X8X60,		//0x08
	MODE_800X600X8X75,		//0x09
	MODE_800X600X16X60,		//0x0a
	MODE_800X600X16X75,		//0x0b

	MODE_800X600X24X60,		//0x0c
	MODE_800X600X24X75,		//0x0d
	MODE_800X600X32X60,		//0x0e
	MODE_800X600X32X75,		//0x0f

	MODE_1024X768X8X60,		//0x10
	MODE_1024X768X8X75,		//0x11
	MODE_1024X768X16X60,	//0x12
	MODE_1024X768X16X75,	//0x13

	MODE_1024X768X24X60,	//0x14
	MODE_1024X768X24X75,	//0x15
	MODE_1024X768X32X60,	//0x16
	MODE_1024X768X32X75,	//0x17

	MODE_1280X1024X8X60,	//0x18
	MODE_1280X1024X8X75,	//0x19

	MODE_1280X1024X16X60,	//0x1a
	MODE_1280X1024X24X60,	//0x1b
	MODE_1280X1024X32X60,	//0x1c
//
	MODE_1280X1024X16X75,	//0x1d
	MODE_1280X1024X24X75,	//0x1e
	MODE_1280X1024X32X75,	//0x1f
//
	MODE_320X240X8X60,		//0x20
	MODE_320X240X16X60,		//0x21
	MODE_320X240X32X60,		//0x22
	MODE_800X480X8X60,		//0x23
	MODE_800X480X16X60,		//0x24
	MODE_800X480X32X60,		//0x25
}MODEDEF;

#define TUCMD_COPYVRAM		0x0d
#define TUCMD_DISABLE		0x0e
#define TUCMD_DOOVERLAY		0x0f
#define TUCMD_COPYVRAM_EXA	0x10
#define TUCMD_USERTEST		0x11
#define TUCMD_OVERLAY_PAR	0x12
#define TUCMD_OVERLAY_DO	0x13
#define TUCMD_EDID			0x14

typedef struct _SISUSB_COMMAND sisusb_command, *psisusb_command;

struct _SISUSB_COMMAND {
	char operation;	/* see below */
	char data0;		/* operation dependent */
	char data1;		/* operation dependent */
	char data2;		/* operation dependent */
	unsigned long data3;		/* operation dependent */
	unsigned long data4;		/* for future use */
	unsigned long data5;		/* operation dependent */
	unsigned long data6;		/* for future use */
	unsigned long data7;		/* for future use */
	unsigned long  data8;		/* for future use */
	unsigned long  data9;		/* for future use */	
	unsigned char *data10;
	unsigned long data11; 
	unsigned long data12; 
	unsigned long data13; 
};

#if 0

struct sisusb_command{
	__u8           operation;	/* see below */
	
	#if 0	
	__u32          par1;
	__u32          par0;
	unsigned char* buf;
	__u32          buflen;	
	#else
	__u8   data0;		/* operation dependent */
	__u8   data1;		/* operation dependent */
	__u8   data2;		/* operation dependent */
	__u32  data3;		/* operation dependent */
	__u32  data4;		/* for future use */
	__u32  data5;		/* operation dependent */
	__u32  data6;		/* for future use */
	__u32  data7;		/* operation dependent */
	__u32  data8;		/* for future use */
	__u32  data9;		/* for future use */	
	unsigned char *data10;
	__u32 data11; 
	__u32 data12; 
	__u32 data13; 
	#endif
};

#endif

static void fill_color_in_dc(unsigned char red, unsigned char green, unsigned char blue, int bpp, unsigned char *dc, int size)
{
	int i;
	unsigned char color_str[bpp/8];

	color_str[0] = blue;
	color_str[1] = green;
	color_str[2] = red;
	color_str[3] = 0; // alpha

	for(i=0;i<size/(bpp/8);i++)
		memcpy(dc+i*(bpp/8), color_str, bpp/8);
}

int main(){

	int fd = 0, num, i=0;
	char buf;
	char *fbp = NULL;
	unsigned long ioctlCmd[5], rectCmd[5], color, width, height;
	
	unsigned char memDC[1024*768*3], available[0x25];
	unsigned char testDC[3][720*480*3];

	unsigned char select, vgaMode, name[16], findit = 0;
	int f1, pause, x1, y1;

	sisusb_command x;
	time_t begin_time, end_time;

	#ifdef userTest_DRAWIMG

	
	fd = open("/dev/triggerusbvga0" , O_RDWR);

	if(fd < 0)

    {

        printf("Error: cannot open trigger device.\n");

        exit(1);

    }
	
	//set VGA mode
	x.operation = 0x09;
	x.data3 = MODE_1024X768X24X60;
	//x.data3 = 2;
	num = ioctl(fd, 0, &x); // 


	width = 320;
	height = 200;
	x1 = 10;
	y1 = 50;
		
	if(num < 0){
			printf("Error: set mode error.\n");
	}

	printf("WHS: %s: set mode done.\n", __func__);

	printf("=========== Demo 1: The moving rectangle ===========\n");
	for(f1=0; f1<400; f1+=4){
		
		// memDC: your RAW image in memory
		fill_color_in_dc(0, 0, 0, 24, memDC, width*height*3);
	
		x.operation = TUCMD_COPYVRAM;
		x.data3 = width; // image width
		x.data4 = height; // image height
		x.data5 = x1 + f1 - 4; // image's left-top coordinate (x, y) = (x.data5, x.data6)
		x.data6 = 50;
		x.data7 = (width);
		x.data8 = (height);
		x.data10 = memDC;
		x.data12 = (0x4000);
		x.data13 = (0x4000);
	
		num = ioctl(fd, 0, &x); 
		
		
		if(num < 0){
			printf("Error: ioctl error.\n");
			close(fd); break;
		}
	
		// memDC: your RAW image in memory
		fill_color_in_dc(255, 255, 0, 24, memDC, width*height*3);
	
		x.operation = TUCMD_COPYVRAM;
		x.data3 = width; // image width
		x.data4 = height; // image height
		x.data5 = x1 + f1; // image's left-top coordinate (x, y) = (x.data5, x.data6)
		x.data6 = 50;
		x.data7 = (width);
		x.data8 = (height);
		x.data10 = memDC;
		x.data12 = (0x4000);
		x.data13 = (0x4000);
	
		num = ioctl(fd, 0, &x); 
	
		if(num < 0){
			printf("Error: ioctl error.\n");
			close(fd); break;
		}

		usleep(50000);

	}

	close(fd);

	return 0;
		
	printf("=========== Demo 2: Performance Test ===========\n");
	//Fill Screen with black
	fill_color_in_dc(0, 0, 0, 24, memDC, 1024*768*3);
	x.operation = TUCMD_COPYVRAM;
	x.data3 = 1024; // image width
	x.data4 = 768; // image height
	x.data5 = 0; // image's left-top coordinate (x, y) = (x.data5, x.data6)
	x.data6 = 0;
	x.data7 = 1024;
	x.data8 = 768;
	x.data10 = memDC;
	x.data12 = (0x4000);
	x.data13 = (0x4000);
	num = ioctl(fd, 0, &x); 
	
	fill_color_in_dc(255, 0, 0, 24, testDC[0], 720*480*3);
	fill_color_in_dc(0, 255, 0, 24, testDC[1], 720*480*3);
	fill_color_in_dc(0, 0, 255, 24, testDC[2], 720*480*3);

	begin_time = time((time_t *)0);
	for(i=0;i<128;i++) {
		x.operation = TUCMD_COPYVRAM;
		x.data3 = 720; // image width
		x.data4 = 480; // image height
		x.data5 = 152; // image's left-top coordinate (x, y) = (x.data5, x.data6)
		x.data6 = 144;
		x.data7 = 720;
		x.data8 = 480;
		x.data10 = testDC[i%3];
		x.data12 = (0x4000);
		x.data13 = (0x4000);
		num = ioctl(fd, 0, &x); 
	}
	end_time = time((time_t *)0);

	printf("Spend %d seconds to complete 128 frames(720x480x3), its about %d frames/sec .\n", end_time - begin_time, 128/(end_time - begin_time));
	close(fd);



	return 0;
	
		//#endif
	

	#else

	//#if 0

	int i = 0;

	available[0x00] = 0;
	available[0x01] = 0;
	available[0x02] = 0;
	available[0x03] = 0;
	available[0x04] = 1;
	available[0x05] = 1;
	available[0x06] = 1;
	available[0x07] = 1;
	available[0x08] = 0;
	available[0x09] = 0;
	available[0x0a] = 0;
	available[0x0b] = 0;
	available[0x0c] = 1;
	available[0x0d] = 1;
	available[0x0e] = 1;
	available[0x0f] = 1;
	available[0x10] = 0;
	available[0x11] = 0;
	available[0x12] = 0;
	available[0x13] = 0;

	available[0x14] = 1;
	available[0x15] = 1;
	available[0x16] = 1;
	available[0x17] = 1;
	available[0x18] = 0;
	available[0x19] = 0;

	available[0x1a] = 0;
	available[0x1b] = 1;
	available[0x1c] = 1;
	available[0x1d] = 0;
	available[0x1e] = 1;
	available[0x1f] = 1;

	available[0x20] = 0;
	available[0x21] = 0;
	available[0x22] = 1;
	available[0x23] = 0;
	available[0x24] = 0;	
	available[0x25] = 1;	
		
	// [WHS: to locate fb node

	do{

		#ifdef FB_SUPPORT

		if(i <= 7) sprintf(name, "/dev/fb%ld", i);
		else sprintf(name, "/dev/fb/%ld", i - 8);

		printf("fb filename: %s\n", name);

		#else

		sprintf(name, "/dev/triggerusbvga%ld", i);
		
		printf("try usb dongle at %s\n", name);

		#endif

		if((fd = open(name , O_RDWR)) != -1){
			
			if(!ioctl(fd, 1, ioctlCmd)){ // WHS: 1 means TUSB_ISTUSB


				if(ioctlCmd[0] == 0xffff){

					findit = 1;
					break;

				}
				else{ 
					close(fd); 
				}

			}
									
		}

		i++;

	}while(i <= 15);

	if(findit){

		#ifdef FB_SUPPORT

		printf("fb node for TRIGGER found\n");

		#else

		printf("dev node for TRIGGER found\n");

		#endif

	}
	else{ 

		#ifdef FB_SUPPORT

		printf("The fb node not found\n");

		#else

		printf("The dev node not found\n");

		#endif
		
		close(fd);		
		return 0;
		
	}

	// WHS: to locate fb node]
		
	do{

		printf("m)Set vga mode c)Specify a color r)Specify a rect d)Do e)Exit\n");
		scanf("%c", &select);		

		switch(select){

			unsigned long r, g, b;

			case 'm': 
	
			printf("Set a graphic mode to mode\n");
			scanf("%d", &vgaMode);

			ioctlCmd[0] = 0x09; // WHS: SUCMD_SETMODE
			ioctlCmd[1] = vgaMode;			

			if(available[ioctlCmd[1]]){

				num = ioctl(fd, 0, ioctlCmd);

				printf("Set a graphic mode to mode 0x%x\n", vgaMode);

			}
			else{

				printf("Mode%d is not supported.\n", ioctlCmd[1]);

			}

			break;

			case 'c':

			printf("Set R\n");
			scanf("%d", &r);

			printf("Set G\n");
			scanf("%d", &g);

			printf("Set B\n");
			scanf("%d", &b);

			#ifdef FB_SUPPORT

			rectCmd[0] = 1;
			rectCmd[5] = (b|(g << 8)|(r << 16));						

			num = ioctl(fd, 0, rectCmd);	

			#else

			x.operation = 0x11;
			x.data7 = (b|(g << 8)|(r << 16));
			
			num = ioctl(fd, 0, &x);

			#endif

			break;
			case 'r':
			
			rectCmd[0] = 1;
			printf("Set DestX\n");
			scanf("%d", &(rectCmd[1]));
			printf("Set DestY\n");
			scanf("%d", &(rectCmd[2]));
			printf("Set ScrXPoint\n");
			scanf("%d", &(rectCmd[3]));
			printf("Set ScrXPoint\n");
			scanf("%d", &(rectCmd[4]));

			#ifdef FB_SUPPORT

			num = ioctl(fd, 0, rectCmd);

			#else

			x.operation = 0x11;
			x.data3 = rectCmd[1];
			x.data4 = rectCmd[2];
			x.data5 = rectCmd[3];
			x.data6 = rectCmd[4];

			num = ioctl(fd, 0, &x);

			#endif

			break;
			case 'd':

			if(available[ioctlCmd[1]]){

				//rectCmd[0] = 1;

				//num = ioctl(fd, 0, rectCmd);	
	
				write(fd, NULL, 0);

			}
			else{

				printf("Mode%d is not supported.\n", ioctlCmd[1]);

			}

			break;
			case 'e':			
			break;
			default: 
			break;

		}

		if(select == 'e') break;

		//printf("\n");

	}while(1);

	close(fd);

	return 0;

	//printf("Set a graphic mode to mode %d\n", vgaMode);
	//scanf("%d\n", &vgaMode);

	#endif

}
